<?php
// $Id: catalog_finder_stuff.inc.php 5140 2012-04-11 15:02:10Z calicant $
// file che si occupa di generare il pannello di ricerca nel catalogo
// incluso da tag_linear.inc

require "modules/catalogo/lang/$cat_lang/catalogo.diz";

$debug = 0;
$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

function get_catalog_look ($look, &$cssfilename) {
/*
global $connh, $TABLE_CATALOGO;

    $dbquery = "SELECT look FROM $TABLE_CATALOGO WHERE id = '$gid'";
    $rslook = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
    if ($rslook->RecordCount()) {
        $cssfilename = $rslook->fields('look'); 
        return substr($cssfilename, 0, -4);
    }        
    else
        return '';
*/

    if (strlen(trim($look)) == 0)
        $look = 'default';
    $cssfilename = $look . '.css';                

} // get_catalog_look

if (!function_exists('stampa_tenda_catalogo')) {

function stampa_tenda_catalogo($nome, $currid, &$nomi_catalogo, &$subst) {
global $connh, $TABLE_CATALOGO, $MYSPACE, $SELECTED_VAL, $CATLOOK;
global $catalogo_node;

$VUOTA_VAL = 0;
$VUOTA_STR = $MYSPACE . catalog_search_allcatalogs . $MYSPACE;

    $nomi_catalogo = array();

    $hidden_calc = '';
    $actionselect =
        "onchange = 'document.forms.catalog_search.submit();'";    
 
    $subst .= "<select $actionselect class=\"" . $CATLOOK . "_input\" size=\"1\" name=\"$nome\" id=\"$nome\">\n";
     
    $selvuota = $currid == $VUOTA_VAL ? $SELECTED_VAL : '';
    $subst .= "<option $selvuota value=\"0\">$VUOTA_STR</option>\n";

    $dbquery = "SELECT id, nome FROM $TABLE_CATALOGO";
    $elenco_catalogo = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());    


    while (!$elenco_catalogo->EOF) {
        $rowg = $elenco_catalogo->fields;
        $status = $rowg[id] == $currid ? $SELECTED_VAL : '';
        $subst .= "<option $status value=\"$rowg[id]\">$MYSPACE" . $rowg[nome] . "$MYSPACE</option>\n";
        $nomi_catalogo[$rowg[id]] = $rowg[nome];
        // in altri contesti questa riga ci avrebbe fatto risparmiare un po' di conti
        // Cfr. catalog_finder.php
        if (isset($catalogo_node[$rowg[id]]))
            $hidden_calc .= "<input type=\"hidden\" name=\"catalogo_node[" . $rowg[id] . "]\" id=\"catalogo_node[" . $rowg[id] . "]\" value=\"" . $catalogo_node[$rowg[id]] . "\" />\n";
        $elenco_catalogo->MoveNext();
    } // while

    $subst .= "</select>\n";

return $hidden_calc;
} // stampa_tenda_catalogo

}

function stampa_ricerca_and_or ($nome, $currval, &$subst) {
global $MYSPACE, $SELECTED_VAL, $CATLOOK;
$STR_AND = $MYSPACE . catalog_search_and . $MYSPACE;
$STR_OR = $MYSPACE . catalog_search_or . $MYSPACE;

    $subst .= "<select class=\"" . $CATLOOK . "_input\" size=\"1\" name=\"$nome\">\n"; 
    $selAND = $currval == 'AND' ? $SELECTED_VAL : '';
    $selOR = $currval == 'OR' ? $SELECTED_VAL : '';    
    $subst .= "<option $selAND value=\"AND\">$STR_AND</option>\n<option $selOR value=\"OR\">$STR_OR</option>\n</select>\n";

} // stampa_ricerca_and_or

function stampa_tenda_modo_ricerca ($nome, $currval, &$subst) {
global $MYSPACE, $SELECTED_VAL, $CATLOOK;
$STR_EQUAL = $MYSPACE . catalog_search_equalto . $MYSPACE;
$STR_IN = $MYSPACE . catalog_search_contains . $MYSPACE;

    $subst .= "<select class=\"" . $CATLOOK . "_input\" size=\"1\" name=\"$nome\">\n"; 
    $selEQUAL = $currval == '=' ? $SELECTED_VAL : '';
    $selIN = $currval == 'IN' ? $SELECTED_VAL : '';    

    $subst .= "<option $selIN value=\"IN\">$STR_IN</option>\n<option $selEQUAL value=\"=\">$STR_EQUAL</option>\n</select>\n";
} // stampa_tenda_modo_ricerca

function stampa_tenda_ordinamento($nome, $nomi_buoni, $currval, &$subst) {
global $MYSPACE, $SELECTED_VAL, $CATLOOK;

    $subst .= "<select class=\"" . $CATLOOK . "_input\" size=\"1\" name=\"$nome\">\n"; 
    foreach ($nomi_buoni as $currname) {
        $status = $currname == $currval ? $SELECTED_VAL : '';    
        $subst .= "<option $status value=\"$currname\">$MYSPACE" . $currname . "$MYSPACE</option>\n";
    } // foreach
    $subst .= "</select>\n";
} // stampa_tenda_ordinamento

function stampa_tenda_ordinamento_verso ($nome, $currval, &$subst) {
global $MYSPACE;

$STR_ASC = $MYSPACE . catalog_search_asc . $MYSPACE;
$STR_DESC = $MYSPACE . catalog_search_desc . $MYSPACE;
$SELECTED_VAL = "SELECTED";

    $subst .= "<select class=\"" . $CATLOOK . "_input\" size=\"1\" name=\"$nome\">\n"; 
    $selASC = $currval == 'ASC' ? $SELECTED_VAL : '';
    $selDESC = $currval == 'DESC' ? $SELECTED_VAL : '';    
    $subst .= "<option $selASC value=\"ASC\">$STR_ASC</option>\n<option $selDESC value=\"DESC\">$STR_DESC</option>\n</select>\n";
} // stampa_tenda_ordinamento_verso


// test per prendere campi utili C -> varchar, X -> text, I -> integer
function is_a_text_type ($type) {

    $type_pulito = strtoupper(trim($type));
 
return ($type_pulito == "C" || $type_pulito == "X");
}


function stampa_elenco_campi_catalogo ($gid, &$subst) {
global $connh, $TABLE_CATALOGO, $TABLE_CATALOGO_CONTENT, $DEFAULT_SIZE, $DEFAULT_CELLS, $DEFAULT_CELLP, $MYSPACE, $debug;
global $cs_orderby, $cs_order_verso, $cs_search_mode, $cs_and_or, $cs_name, $CATLOOK;

    // mostriamo solo i campi presenti nel template di un dato catalogo_content
    if ($gid) {
        $filter_template_fields = 1;
        $dbquery = "SELECT template FROM $TABLE_CATALOGO WHERE id = '$gid'";
        $rowcatrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
        
        if ($rowcatrs->RecordCount() > 0) {
            $rowcat = $rowcatrs->fields;

            // si vede se c'e' un commento con i campi voluti
            // del tipo <!-- search_fields:field1,field2 -->
            //

            $a_good_fields = array();
            $fixedfields = preg_match("/<!--\s*search_fields:(.+):\s*-->/", $rowcat['template'], $regs2);


            $no_order = "";
            $noorderstatus = preg_match("/<!--\s*disableorderby:(.+):\s*-->/", $rowcat['template'], $regs2bis);
            if ($noorderstatus)
                $no_order = $regs2bis[1];
            
            if ($fixedfields && trim($regs2[1]) != '')
                $campi_catalogo = explode(",", $regs2[1]);
            else {
                preg_match_all("/\{(\w+)\}/", $rowcat[template], $regs);
                $campi_catalogo = $regs[1];
                $contaf = count($campi_catalogo);
                if (!$contaf)
                    $filter_template_fields = 0;
                else
                    for ($k = 0; $k < $contaf; $k++)
                        $campi_catalogo[$k] = strtolower($campi_catalogo[$k]);
            }
        }
        else $filter_template_fields = 0;
    }
    else $filter_template_fields = 0;


    $subst .= "<table class=\"$CATLOOK" . "_table\" cellspacing=\"$DEFAULT_CELLS\" cellpadding=\"$DEFAULT_CELLP\">\n";
    $nomi_buoni = array();
    
    if (!isset($cs_order_verso))
        $cs_order_verso = 'ASC';

    $nstampa = 0;
    $dbquery = "SELECT * FROM $TABLE_CATALOGO_CONTENT";
    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());

    for ($i = 0; $i < $rowrs->FieldCount(); $i++) {
        $field = $rowrs->FetchField($i);
        $type = $rowrs->MetaType($field->type);
        $nome = strtolower($field->name);
        $filter_good = ($filter_template_fields == 0) || ($filter_template_fields && in_array($nome, $campi_catalogo));
            

        // nota bene: qui si cerca solo in campi testo    
        if (is_a_text_type($type) && $filter_good) {
            $nstampa++;
            if (!isset($cs_and_or[$nome]))
                $cs_and_or[$nome] = 'AND';
                        
            if ($nstampa != 1) {
                $subst .= "<td class=\"" . $CATLOOK . "_td\">";
                stampa_ricerca_and_or ("cs_and_or[$nome]", $cs_and_or[$nome], $subst);
                $subst .= "</td>\n</tr>\n";
            }
            else {
                $subst .= "<td class=\"" . $CATLOOK . "_td\"><input type=\"hidden\" name=\"cs_and_or[$nome]\" id=\"cs_and_or[$nome]\" value=\"AND\" /></td>\n</tr>\n";
                if (!isset($cs_orderby))
                    $cs_orderby = $nome;
            }                
            $nomi_buoni[] = $nome;
            $outnome = strtoupper($nome);
            $subst .= "<tr class=\"" . $CATLOOK . "_tr\">\n<td class=\"" . $CATLOOK . "_titolo\">" . $outnome . "</td>\n<td class=\"" . $CATLOOK . "_td\">";
            if (!isset($cs_search_mode[$nome]))
                $cs_search_mode[$nome] = '';
 
            if (!isset($cs_name[$nome]))
                $cs_name = '';

            stampa_tenda_modo_ricerca("cs_search_mode[$nome]", $cs_search_mode[$nome], $subst);
            $subst .= "</td>\n<td class=\"" . $CATLOOK . "_td\"><input type=\"text\" class=\"" . $CATLOOK . "_input\" name=\"cs_name[$nome]\" id=\"cs_name[$nome]\" value=\"$cs_name[$nome]\" size=\"$DEFAULT_SIZE\" /></td>\n";
        } // if (is_a_text_type
    } // for
    
    // stampa di opzioni di ordinamento e pulsante inizio ricerca
    if ($nstampa) {

        if ($no_order == "yes")
            $subst .=
                "<tr>\n" .
                "<td class=\"" . $CATLOOK . "_input\" colspan=\"4\">" .
                "<input type=\"submit\" class=\"" . $CATLOOK . "_button\" name=\"bCatalogSearchGo\" id=\"bCatalogSearchGo\" value=\"" . catalog_search_searchstart . "\" />" .
                "</td>\n</tr>\n";

        else {
            $subst .= "<tr>\n<td>&nbsp;</td>\n</tr>\n<tr class=\"" . $CATLOOK . "_tr\">\n<td class=\"" . $CATLOOK . "_titolo\" colspan=\"1\">".
            catalog_search_orderby . $MYSPACE .
            "</td><td class=\"" . $CATLOOK . "_input\" colspan=\"3\">";

            stampa_tenda_ordinamento('cs_orderby', $nomi_buoni, $cs_orderby, $subst);
            stampa_tenda_ordinamento_verso('cs_order_verso', $cs_order_verso, $subst);

            $subst .= 
                "<input type=\"submit\" class=\"" . $CATLOOK . "_button\" name=\"bCatalogSearchGo\" id=\"bCatalogSearchGo\" value=\"" . catalog_search_searchstart . "\" />" .
                "</td>\n</tr>\n";

        } // else
    } 
    unset($nomi_buoni);
    $subst .= "</table>\n";
} // stampa_elenco_campi_catalogo


    $CATLOOK == '';
    $TABLE_CATALOGO = 'catalogo';
    $TABLE_CATALOGO_CONTENT     = 'catalogo_content'; 
    $DEFAULT_SIZE               = 30;
    $DEFAULT_CELLS              = 2;
    $DEFAULT_CELLP              = 2;
    $MYSPACE                    = '&nbsp;&nbsp;';
    $SELECTED_VAL               = "SELECTED";
    $subst                      = '';

    if (isset($id_catalogo_fix) && is_numeric($id_catalogo_fix) && $id_catalogo_fix) {
        $search_id_catalogo = $id_catalogo_fix;
        get_catalog_look ($CATLOOK, $cssfilename);
        
        if ($cssfilename != '')
            $subst .= "\n<link rel=\"stylesheet\" type=\"text/css\" href=\"look/$cssfilename\">";
    }

    if (!isset($search_id_catalogo))
        $search_id_catalogo = 0;        
    
    
    $subst .= "<form name=\"catalog_search\" action=\"modules/catalogo/lib/catalog_finder.php\" method=\"POST\">\n";
    // codice per una possibile funzione di ricerca sui catalogi
    if ($search_id_catalogo)
        $subst .= "<input type=\"hidden\" name=\"search_id_catalogo\" id=\"search_id_catalogo\" value=\"$search_id_catalogo\" />\n";
    else {
        $subst .= "<strong><label for=\"search_id_catalogo\">Cerca in</label>: </strong>\n";
        $hidden_calc = stampa_tenda_catalogo('search_id_catalogo', $search_id_catalogo, $nomi_catalogo, $subst);
    }
    // stampa dei campi del tipo di ricerca    
    stampa_elenco_campi_catalogo($search_id_catalogo, $subst);
    // ci portiamo dietro un po' di informazioni hidden per non doverle ricalcolare
    $subst .= $hidden_calc;
    $subst .=
    		"<input type=\"hidden\" name=\"idp\" id=\"idp\" value=\"$idp\" />\n" .
		"<input type=\"hidden\" name=\"catalog_page_id\" value=\"$catalog_page_id\" />\n" .
    		"</form>\n";


echo $subst;
?>
