<?

// $Id: feeds_loop.inc.php 5196 2012-12-05 08:10:24Z calicant $

require_once PRISCILLA_LOCAL_PATH . "modules/feeds/inc/config.inc.php";
require_once PRISCILLA_LOCAL_PATH . "modules/feeds/lib/feed_parser.php";


#set_include_path(get_include_path() . PATH_SEPARATOR . "/var/www/vhost/" . "packages/zend/library/");
#require_once "/var/www/vhost/" . "packages/zend/library/Zend/Feed/Reader.php";

function parseRSS($url) { 
 
    //PARSE RSS FEED
        $feedeed = implode('', file($url));
        $parser = xml_parser_create();
        xml_parse_into_struct($parser, $feedeed, $valueals, $index);
        xml_parser_free($parser);
 
    //CONSTRUCT ARRAY
        foreach($valueals as $keyey => $valueal){
            if($valueal['type'] != 'cdata') {
                $item[$keyey] = $valueal;
            }
        }
 
        $i = 0;
 
        foreach($item as $key => $value){
 
            if($value['type'] == 'open') {
 
                $i++;
                $itemame[$i] = $value['tag'];
 
            } elseif($value['type'] == 'close') {
 
                $feed = $values[$i];
                $item = $itemame[$i];
                $i--;
 
                if(count($values[$i])>1){
                    $values[$i][$item][] = $feed;
                } else {
                    $values[$i][$item] = $feed;
                }
 
            } else {
                $values[$i][$value['tag']] = $value['value'];  
            }
        }
 
    //RETURN ARRAY VALUES
        return $values[0];
    } 

/**
 ** tag: feed
  ** desc: lettura di feeds RSS
 ** opt: url path http al feed xml (richiesto)
 ** opt: enconding set di caratteri da usare, se non fornito cerca di auto-capirlo
 ** opt: n numero di item da mostrare, se non fornito n = 5
 ** eg: <%feed url="http://www.repubblica.it/rss/politica/rss2.0.xml" n="3" encoding="utf-8"%>
 ** eg: <a href="{link}">{title}</a><br />
 ** eg: <%end%>
 **/
function feeds (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco) {

    if (trim($options["url"]) != "") {

        $conf = array('url' => $options["url"]);

        if (trim($options['encoding']) != "")
            $conf['encoding'] = $options['encoding'];

        if (trim($options['formatdate'] != ""))
            $conf["formatdate"] = $options["formatdate"];
        else
            $conf["formatdate"] = "d-m-Y";

        if (is_numeric($options['n']))
            $n = $options['n'];
        else
            $n = 5;

        $xml = parseRSS($conf["url"]);
 
        foreach($xml['RSS']['CHANNEL']['ITEM'] as $item) {
            $i++;

            if ($i > $n)
                break;

            $feed = array();
            foreach ($item as $k => $v) {
                $sk = strtolower($k);
                if ($sk == 'pubdate')
                    $v = date($conf["formatdate"], strtotime($v));
                $feed[$sk] = $v;
            }

            $publisher->publish($blocco, $risoluzione, $feed);
        }
    }
}


/**
 ** tag: feedreader
 ** desc: ATTENZIONE, deprecato usare feed
 ** desc: lettura di feeds RSS
 ** desc: attenzione: deve essere installata sul server la libreria Zend in /var/www/vhost/packages/zend/ (percorso fisso)
 ** opt: url path http al feed xml (richiesto)
 ** opt: n numero di item da mostrare, se non fornito n = 5
 ** opt: splitimage se posto a yes separa l'immagine dall contenuto e la fornisce in {image}
 ** eg: <%feedreader url="http://www.repubblica.it/rss/politica/rss2.0.xml" n="3"%>
 ** eg: <a href="{link}">{title}</a><br />
 ** eg: <%end%>
 **/
function feedreader (&$connh, &$content, $risoluzione, &$PRISCILLA_SESSION, $options, &$publisher, $blocco) {

    return false;

    if (trim($options["url"]) == "")
        return "";
    else
	$url = $options["url"];

    if (is_numeric($options['n']))
        $n = $options['n'];
    else
        $n = 5;

    try {
    $feed = Zend_Feed_Reader::import($url);
    }
    catch (Exception $e) {
     echo 'Exception caught: ',  $e->getMessage(), "\n";
     return "";
    }    


    $data = array(
        'title'        => $feed->getTitle(),
        'link'         => $feed->getLink(),
        'dateModified' => $feed->getDateModified(),
        'description'  => $feed->getDescription(),
        'language'     => $feed->getLanguage(),
        'entries'      => array(),
    );
 
    $i = 0;
    foreach ($feed as $entry) {

        $a_l = explode("/", $entry->getLink());
        foreach ($a_l as $ls)
	    if (is_numeric($ls))
		$idn = $ls;

	$content = $entry->getContent();

	if ($options["splitimage"] == "yes") {
		$a_c = explode("<content:encoded>", $content);

		//print_r($a_c);
		$have_image = preg_match_all('/<img[^>]+>/i', $a_c[0], $res);
		if ($have_image) {
			$content = str_replace($res[0][0], "", $a_c[0]);

			$a_ti = explode('"', $res[0][0]);
			$image = "<img src=\"" . str_replace("medium", "large", $a_ti[3]) . "\" />\n";

		}
		else
			$image = "";
	}

	$l = $entry->getLink();
	$a_l = explode("/", $l);
	$seotitle = $a_l[count($a_l) - 1];

        $edata = array(
            'title'        => $entry->getTitle(),
            'description'  => $entry->getDescription(),
	    'dateModified' => $entry->getDateModified()->toString(),
//            'authors'      => array_shift($entry->getAuthors()->getValues()),
            'link'         => $entry->getLink(),
            'content'      => $content,
            'idn'	   => $idn,
	    'picture'	   => $image,
	    'seotitle'     => $seotitle,
        );
	//$data['entries'][] = $edata;


        $publisher->publish($blocco, $risoluzione, $edata);

        unset($edata);

        $i++;
        if ($i >= $n)
            break;
    }
}

?>
