<?php
// $Id: module_body.inc.php 5189 2012-10-04 07:54:58Z calicant $

require_once PRISCILLA_LOCAL_PATH."adm/lib/test_auth.php";

// estraggo i dati dell'utente (per personalizzazioni)
$usertable = $PRISCILLA_SESSION->getvalue('usertable');
if ($usertable[skin] != '') $skin = $usertable[skin];
if ($usertable[lingua] != '') $lang = $usertable[lingua];
require_once PRISCILLA_LOCAL_PATH . "tools/lang/$lang/adm_dialog.diz";
require_once PRISCILLA_LOCAL_PATH . "tools/lang/$lang/error.diz";

// toglobaloff
if (isset($_POST['ftemplate']))
    $ftemplate = $_POST['ftemplate'];
else if (isset($_GET['ftemplate']))
    $ftemplate = $_GET['ftemplate'];

if (isset($_POST['fstile']))
    $fstile = $_POST['fstile'];
else if (isset($_GET['fstile']))
    $fstile = $_GET['fstile'];

if (isset($_POST['finclude']))
    $finclude = $_POST['finclude'];
else if (isset($_GET['finclude']))
    $finclude = $_GET['finclude'];

if (isset($_POST['changedoctype']))
    $changedoctype = $_POST['changedoctype'];
else if (isset($_GET['changedoctype']))
    $changedoctype = $_GET['changedoctype'];

if (isset($_POST['doctemplatefile']))
    $doctemplatefile = $_POST['doctemplatefile'];
else if (isset($_GET['doctemplatefile']))
    $doctemplatefile = $_GET['doctemplatefile'];

if (isset($_POST['doctype']))
    $doctype = $_POST['doctype'];
else if (isset($_GET['doctype']))
    $doctype = $_GET['doctype'];

if (isset($_POST['type']))
    $type = $_POST['type'];
else if (isset($_GET['type']))
    $type = $_GET['type'];

if (isset($_POST['filedel']))
    $filedel = $_POST['filedel'];

if (isset($_POST['del']))
    $del = $_POST['del'];


// directory da ignorare perche' contenenti dati quando si cercano file obsoleti
$a_ignore_dirs = array ("attach", "catalogo", "dump", "include", "pix", "pdf", "style", "templates", "thebanner", "adm/lib/adodb350", "tools/script", "look", "stats");
$a_ignore_file = array ("adm/lib/setup.php", "adm/lib/getmxrr.php", "adm/lib/nusoap.php", "adm/lib/smtp.php");

$llpath = strlen($priscilla_local_path) + 1;

function set_doctype_for_template ($filename, $newdoctype) {
$COOKIE_DOCTYPE = '<!DOCTYPE';

    if (!file_exists($filename))
        die("Fatal Error: template file not found: '$filename'");

    $templatedata = file($filename);
    $lcookie = strlen($COOKIE_DOCTYPE);
    $goodline = -1;

    // un template deve stare su una riga, non spezzato

    for ($i = 0; $i < count ($templatedata); $i++) {
        $line = trim($templatedata[$i]);
        if (strtoupper(substr($line, 0, $lcookie)) == $COOKIE_DOCTYPE) {
            $goodline = $i;
            break;
        } // if
    } // for

    // andiamo a riscrivere il file
    $fp = fopen($filename, "w");
    if (!$fp)
        die("Fatal Error: could not write template file: '$filename'");

    // il doctype manca
    if ($goodline == -1) {
        fputs($fp, $newdoctype . "\n");
    // il doctype va sostituito
    } else {
        $line = trim($templatedata[$goodline]);
        $pos = strpos ($line, '>');
        if ($pos === false)
            ;
        else {
            if (trim($newdoctype) != '')
                $newdoctype .= "\n";
            $templatedata[$i] = $newdoctype . substr($line, $pos + 1);
        }
    }

    // e giu' di brutto con tutta la scrittura

    for($j = 0; $j < count($templatedata); $j++)
        fputs($fp, $templatedata[$j]);
    fclose($fp);

} // set_doctype_for_template


// attenti ai furbi qui
$a_good_dirs = array ("../templates/", "../style/", "../include/");

function get_dir_index ($a_good_dirs, $file) {

    $a_index = -1;

    foreach ($a_good_dirs as $k=>$cdir) {
        if (substr($file, 0, strlen($cdir)) == $cdir) {
            $a_index = $k;
            break;
        } // if
    } // foreach

return $a_index;
}

function is_a_good_filename ($filename) {

    if (strpos($filename, '/') !== false || strpos($filename, '\\') !== false || strpos($filename, '..') !== false)
        return false;
    else
        return true;
}

function recursive_listing ($sPath) {
global $priscilla_local_path, $a_ignore_dirs, $a_ignore_file, $llpath;

    $retVal = array();
    if (($handle = @opendir($sPath)) == false)
        return $retVal;

    while (($file = readdir($handle)) != false) {
        if ($file != "." && $file != "..") {
            $fullPath = "$sPath/$file";
            if (@is_dir($fullPath)) {
                if (!@is_link($fullPath)) {
                    $xdir = substr($fullPath, $llpath);
                    if (!in_array($xdir, $a_ignore_dirs))
                        $retVal = array_merge($retVal, recursive_listing($fullPath));
                }
            }
            else {
                $barefile = substr($fullPath, $llpath);
                if (!in_array($barefile, $a_ignore_file))
                    $retVal[] = $barefile;
            } // else
        } // if
    } // while
    closedir($handle);
    return $retVal;   
}


function getfilelist ($dir, $ext) {

    $filelist = array();
    $handle = opendir($dir);

    while (false !== ($file = readdir($handle)))
        if (!ereg('^\.', $file) && ereg('\.' . $ext . '$', $file))

    $filelist[] = $file;

    closedir($handle);

    sort($filelist);

return $filelist;
}


///////////////////////////////////////////////////////////////////////////////////////////////////


if ($changedoctype == 'now') {

    // echo "FILENAME = *$doctemplatefile* --- DOCTYPE = *$doctype*<br />\n";
    $doctype = stripslashes($doctype);

    if ($doctemplatefile == 'all_templates_now') {
        // applico a tutti i files
        $handle = opendir("../templates");
        while ($file = readdir($handle))
            if ((!ereg('^\.', $file)) and (ereg('\.tpl', $file)))
                set_doctype_for_template ('../templates/' . $file, $doctype);
        closedir($handle);
    }
    else
        set_doctype_for_template ('../templates/' . $doctemplatefile, $doctype);
} // if ($changedoctype


if ($del) {
    if (is_array($filedel) and count($filedel) > 0) {
        foreach ($filedel as $file) {
            // si fa anche un controllo si quali directory e' possibile eliminare
            $a_index = get_dir_index($a_good_dirs, $file);
            if ($a_index != -1) {
                $otherpath = substr($file, strlen($a_good_dirs[$a_index]));
                if (is_a_good_filename($otherpath)) {
                    if (!unlink($file))
                        $errordel[] = $file;

                } // if
            } // if
        } // foreach
    } // if
} // if


// eliminazione file obsoleti
if (isset($_POST['delobsolete']) && isset($_POST['obsoletefile']) && is_array($_POST['obsoletefile']) && count ($_POST['obsoletefile'])) {

    $obsolete_del_error = false;
    $obsolete_no_deleted = 0;

    foreach ($_POST['obsoletefile'] as $todelfile) {

        if (strpos($todelfile, "..") === false) {
            if (file_exists($priscilla_local_path . $todelfile)) {
                if (!unlink($priscilla_local_path . $todelfile))
                    $obsolete_del_error++;
                else $obsolete_no_deleted++;
            }
        }
    }
}

//include PRISCILLA_LOCAL_PATH."adm/include/html_head.inc.php";
//include("include/title.txt");
//print "<link rel=\"stylesheet\" type=\"text/css\" href=\"skin/$skin/default.css\">";
include("include/OpenWnd.js");

echo <<< END
<script language="javascript" type="text/javascript">

function gom (f) {

    if (f == '')
        return;

    ext = f.substring(f.lastIndexOf(".") + 1);

    cdir = ''; 

    if (ext == 'tpl')
        cdir = "/templates/";

    if (ext == "txt")
        cdir = "/include/"; 

    alert(cdir);

    if (cdir != '')
        OpenWnd('winseditor.php?file=..' + cdir  + f);
}
</script>
END;


//include("skin/$skin/body.inc");
//include("include/head_adm.inc.php");

if (isset($_POST['bFindUnusedFile'])) {

    if (!isset($priscilla_local_path))
        die("priscilla_local_path is undefined.\n");


if (!$PRISCILLA_SESSION->exists('priscilla_remote_files')) {

    require_once "lib/nusoap.php";

    // alla ricerca della lista dei file remoti

    // ----- GET_LAST_VERSION
    $serverpath = $priscilla_update_mirror . "get_last_version.php";
    $client = new soapclient0($serverpath);

    if ($fault = $client->getError()) {
                print "error: ". $fault;
                die();
    }


    $last_version = $client->call("get_last_version");

    if ($fault = $client->getError()) {
        print "<br /><span style=\"color:red\"><strong>".$fault."</strong></span>";
        die();
    }
    unset($client);

    // ----- GET_ALL_FILES
    $serverpath = $priscilla_update_mirror . "get_all_files.php";
    $client = new soapclient0($serverpath);
    if ($fault = $client->getError()) {
        print "error: ". $fault;
        die();
    }

    $param = array("version" => $last_version);
    $remote_files = $client->call("get_all_files", $param);
    if ($fault = $client->getError()) {
        print "<br /><span style=\"color:red\"><strong>".$fault."</strong></span>";
        die();
    }
    unset($client);

    $PRISCILLA_SESSION->add('priscilla_remote_files', $remote_files);

}
else $remote_files = $PRISCILLA_SESSION->getvalue('priscilla_remote_files');

    // l'elenco dei files locali
    $local_files = recursive_listing($priscilla_local_path);
    $obsolete_files = array_diff($local_files, $remote_files);

// stampa dell'interfaccia per eliminare i file aggiuntivi

$a_width = file("include/dim_all.inc.php"); 

if (count($obsolete_files)) {

echo <<< EOF
<form method="post"><input type="hidden" name="delobsolete" value="true" />
<table width="$a_width[0]" class="table_border" cellpadding="2" cellspacing="1" border="0"><tr>
    <th colspan="3" class="table_tit">adm_sedit_obsolete_search_title</th>
</tr><tr><td width="80%" class="table_sez"><strong><div class="insert_message">adm_sedit_obsolete_file_warn (!!!)</div></strong></td>
    <td width="15%" class="table_sez">adm_sedit_size</td>
    <td width="5%" class="table_sez"><input type="submit" value="adm_voice_del" class="button_in awesome"></td>
</tr>
EOF;

    $riga = 0;

    foreach ($obsolete_files as $file) {

            if ($riga % 2 == 0) $class = "insert_voice";
            else $class = "insert_voice_dark";
            $filesize = filesize($priscilla_local_path . $file);
            if ($filesize > 1024)
                $filesize = "Kb " . number_format($filesize / 1024, 2, ",", "");
            else $filesize = "Byte ".$filesize;
            echo "<tr><td class=\"$class\">$file";
            echo "</td>
            <td class=\"$class\">$filesize</td>
            <td align=\"center\" class=\"$class\"><input type=\"checkbox\" checked name=\"obsoletefile[]\" value=\"$file\"></td>
            </tr>";
            $riga++;
    } // foreach

    echo "</table></form>\n";
}


}
?>

<?php
if ($ftemplate)
{
    $file="../templates/".$ftemplate;
    echo "<script language=\"javascript\" type=\"text/javascript\">OpenWnd('winseditor.php?file=$file')</script>";
}

if ($fstile)
{
    $file="../style/".$fstile;
    echo "<script language=\"javascript\" type=\"text/javascript\">OpenWnd('winseditor.php?file=$file')</script>";
}

if ($finclude)
{
    $file="../include/".$finclude;
    echo "<script language=\"javascript\" type=\"text/javascript\">OpenWnd('winseditor.php?file=$file')</script>";
}
?>

<form method="POST">
<table width="<? include("include/dim_all.inc.php"); ?>" class="table_border" cellpadding="2" cellspacing="1" border="0">
<?
if ($obsolete_del_error || $obsolete_no_deleted) {
$s_message = adm_sedit_obsolete_no_deleted  . ": " . $obsolete_no_deleted;
if ($obsolete_del_error)
    $s_message . "(" . adm_sedit_obsolete_delete_error  . ")"; 
    echo "<tr><td align=\"center\" class=\"table_sez\">$s_message</td></tr>\n";
}
?>
</table>
</form>

<br />
<table width="<? include("include/dim_all.inc.php"); ?>" class="table_border" cellpadding="2" cellspacing="1" border="0"><tr>
    <th colspan="3" class="table_tit"><? print adm_sedit_tt_list; ?> <span style="color:red">TEMPLATES, STYLE, INCLUDE<?php echo strtoupper($dbase) ?></span></th>
    </tr><tr>
    <td valign="top" width="33%" class="insert_voice">
        <table width="100%" class="table_border" align="center" cellpadding="2" cellspacing="1" border="0">
        <tr>
        <th colspan="2" class="table_sez"><? print adm_voice_tpl; ?> <span style="color:red">TEMPLATES<?php echo strtoupper($dbase) ?></span> <a href="gm.php?md=supereditor&type=template"><? echo adm_voice_admin; ?></a></th>
        </tr><form method="post"><tr>
        <td width="50%" class="insert_voice"><select name="ftemplate" style="width:100%" class="insert_area">
<?php
$handle = opendir("../templates");
$flist = array();
while (($file = readdir($handle)) != false)
    if ((!ereg('^\.', $file)) and (ereg('\.mnu$|\.sch$|\.tpl$', $file)))
        $flist[] = $file;
sort($flist);
closedir($handle);

foreach ($flist as $file)
    echo "<option value=\"$file\">$file</option>\n";

?>
        </select></td>
        <td width="50%" align="center" class="button_out"><input type="submit" value="<? print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".adm_voice_edit."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; ?>" class="button_in awesome"></td>
        </tr></form></table>
    </td><td valign="top" width="33%" class="insert_voice">

        <table width="100%" class="table_border" align="center" cellpadding="2" cellspacing="1" border="0">
        <tr>
        <th colspan="2" class="table_sez"><? print adm_sedit_tt_list; ?> <span style="color:red">STYLE <?php echo strtoupper($dbase) ?></span><a href="gm.php?md=supereditor&type=stile"><? echo adm_voice_admin; ?></a></th>
        </tr><form method="post"><tr>
        <td width="50%" class="insert_voice"><select name="fstile" style="width:100%" class="insert_area">
<?php
$handle = opendir("../style");
$flist = array();
while (($file = readdir($handle)) != false)
    if ((!ereg('^\.', $file)) and (ereg('\.css$', $file)))
        $flist[] = $file;
sort($flist);
closedir($handle);

foreach ($flist as $file)
    echo "<option value=\"$file\">$file</option>\n";

?>
        </select></td>
        <td width="50%" align="center" class="button_out"><input type="submit" value="<? print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".adm_voice_edit."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; ?>" class="button_in awesome"></td>
        </tr></form></table>
</td><td valign="top" width="33%" class="insert_voice">
        <table width="100%" class="table_border" align="center" cellpadding="2" cellspacing="1" border="0">
        <tr>
        <th width="50%" colspan="2" class="table_sez"><? print adm_sedit_tt_list; ?> <span style="color:red">INCLUDE<?php echo strtoupper($dbase) ?></span><a href="gm.php?md=supereditor&type=include"><? echo adm_voice_admin; ?></a></th>
        </tr><form method="post"><tr>
        <td idth="50%" class="insert_voice"><select name="finclude" tyle="width:100%" class="insert_area">
<?php

$handle = opendir("../include");
$flist = array();
while (($file = readdir($handle)) != false)
    if ((!ereg('^\.', $file)) and (ereg('\.txt$', $file)))
        $flist[] = $file;
sort($flist);
closedir($handle);

foreach ($flist as $file)
    echo "<option value=\"$file\">$file</option>\n";

?>
        </select></td>
        <td width="50%" align="center" class="button_out"><input type="submit" value="<? print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".adm_voice_edit."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; ?>" class="button_in awesome"></td>
        </tr></form></table>
</td></tr></table>
<br />

<? if (isset($type) or $type != "") {?>
<table width="<? include("include/dim_all.inc.php"); ?>" class="table_border" cellpadding="2" cellspacing="1" border="0"><tr>
    <th colspan="4" class="table_tit"><? echo adm_sedit_adm_tit; ?></th>
</tr><tr><form method="post"><input type="hidden" name="del" value="true" />
    <td width="70%" class="table_sez"><? echo strtoupper($type); ?></td>
    <td width="10%" class="table_sez"><?php echo adm_sedit_used; ?></td>
    <td width="15%" class="table_sez"><?php echo adm_sedit_size; ?></td>
    <td width="5%" class="table_sez"><input type="submit" value="<?php echo adm_voice_del; ?>" class="button_in awesome"></td>
</tr>
<?
    if ($type == "template")
        $dir = "../templates/";
    else if ($type == "stile")
        $dir = "../style/";
    else if ($type == "include")
        $dir = "../include/";


    // conti da fare solo per i file include

    $lista_template = getfilelist ("../templates/", "tpl");
    $lista_include = getfilelist ("../include/", "txt");
    $include_index = array();

    // aggiungiamo gli include ai template per inclusioni di inclusioni

    $lista_template = array_merge ($lista_template, $lista_include); 

    // per ognuno dei template, vediamo quali file di inclusione usa

    foreach ($lista_template as $ctemplate) {

        if (ereg('\.tpl$', $ctemplate))
            $ctemplate_text = file_get_contents ("../templates/" . $ctemplate);

        if (ereg('\.txt$', $ctemplate))
            $ctemplate_text = file_get_contents ("../include/" . $ctemplate);

        foreach ($lista_include as $cinclude) {
            if (strpos($ctemplate_text, $cinclude) !== false)
                $include_index[$cinclude][] = $ctemplate;
            
        } // foreach

    } // foreach
    // fine dei conti per tipo file include


    $riga = 0;

    // lista dei file
    $list_of_files = array();

    $handle = opendir($dir);
    while (($file = readdir($handle)) != false)
        if ((!ereg('^\.', $file)) and (ereg('\.mnu$|\.sch$|\.tpl$|\.txt$', $file) or (ereg('\.css$', $file))))
            $list_of_files[] = $file;
    closedir($handle);

    sort($list_of_files);

    foreach ($list_of_files as $file) {
        if ($riga % 2 == 0) $class = "insert_voice";
        else $class = "insert_voice_dark";

    
        if ($type == 'template' || $type == 'stile') {
            $query = "SELECT sezione FROM node WHERE $type='$file'";
            $rs = $connh->Execute($query);
            $sezioni = $rs->fields('sezione');
            if (($tot = $rs->RecordCount()) <= 0) $tot = 'NO';
        } else {
            // file include trattati in altra maniera

            $tot = "";

            if (isset($include_index[$file])) {
                $tot =  "<select size=\"1\" class=\"insert_voice\" onChange=\"gom(this.options[selectedIndex].value);\">\n";

                $outempty = false;
                $sorted_include = $include_index[$file];
                sort($sorted_include);

                foreach ($sorted_include as $ctemplate) {
                    if (!$outempty) {
                        $tot .= "<option value=\"\"></option>\n";
                        $outempty = true;
                    }
                    $tot .= "<option value=\"$ctemplate\">$ctemplate</option>\n";
                }
                $tot .= "</select>\n";

            }
            else $tot = 'NO';
        }

        $filesize = filesize($dir.$file);
        if ($filesize > 1024)
            $filesize = "Kb " . number_format($filesize / 1024, 2, ",", "");
        else $filesize = "Byte ".$filesize;
        echo "<tr>
        <td class=\"$class\"><a href=\"javascript:OpenWnd('winseditor.php?file=$dir$file')\">$file</a></td>
        <td class=\"$class\">";

        if ($tot != 'NO' && ($type == 'template' || $type == 'stile'))
            echo "<a href=\"javascript:OpenWnd('view_sez.php?file=$file&type=$type')\">$tot</a>";
        else
            echo $tot;

        echo "</td>
            <td class=\"$class\">$filesize</td>
            <td align=\"center\" class=\"$class\"><input type=\"checkbox\" name=\"filedel[]\" value=\"$dir$file\"></td>
        </tr>";
        $riga++;
    } // foreach
?></form>

<?
if (isset($errordel) and count($errordel) > 0)
{
    echo "<tr>
    <td>err_deletefiles:<br />";
    foreach ($errordel as $file)
        echo "$file<br />";
    echo "</td>
    </tr>";
}
?>
</table><br />

<? } ?>
<form name="fchangedoc" method="POST">
<input type="hidden" name="changedoctype" value="now" />
<table align="center" class="table_border" width="<? include("include/dim_all.inc.php"); ?>" cellpadding="3" cellspacing="1" border="0">
<tr>
    <th colspan="3" class="table_tit"><? echo adm_sedit_doctype_tit; ?></th>
</tr>
<tr>
<td width="30%" class="insert_voice">
<select name="doctemplatefile" style="width:100%" class="insert_area">
<?php
$handle = opendir("../templates");
echo "<option value=\"all_templates_now\">" . adm_sedit_doctype_all . "</option>\n";
while ($file = readdir($handle))
{
    if ((!ereg('^\.', $file)) and (ereg('\.tpl', $file)))
    {
        echo "      <option value=\"$file\">$file</option>\n";
    }
}
closedir($handle);
?>
</select>
</td>
<td width="55%" class="insert_voice">
<input type="text" name="doctype" value="<?php echo htmlspecialchars('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'); ?>" style="width:100%" class="insert_area">
</td>
<td width="15%" align="center" class="button_out">
<input type="submit" value="<? print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".adm_voice_edit."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; ?>" class="button_in awesome">
</td>
</tr></form>
</table>
<br />
