<?
// $Id: module_body.inc.php 5140 2012-04-11 15:02:10Z calicant $
require_once "lib/test_auth.php";

require_once PRISCILLA_LOCAL_PATH."modules/swaplang/lib/swaplang.lib.php";


class FakeObj {

    var $name = "";
    var $type = "";
    var $binary = "fakeobj";
}

$tables = $connh->MetaTables();
$rscontents = $connh->Execute("SELECT DISTINCT(contenuto) FROM node");

if ($_POST['action'] == 'newlang') {
    // creazione tabelle di lingua per tabelle di contenuto
    while (!$rscontents->EOF) {
        if (in_array($rscontents->fields['contenuto'].'_lang'.$_POST['newlangname'], $tables))
            echo "<script type=\"text/javascript\">alert('lingua gia` presente nel database per ".$rs->fields['contenuto']."');</script>";
        else {
            $connh->Execute("CREATE TABLE ".$rscontents->fields['contenuto'].'_lang'.$_POST['newlangname']." SELECT * FROM ".$rscontents->fields['contenuto']);
            $tables[] = $rscontents->fields['contenuto'].'_lang'.$_POST['newlangname'];
        }
        $rscontents->MoveNext();
    }
    $rscontents->MoveFirst();

    // creazione lingua per contenuti catalogo
    $connh->Execute("CREATE TABLE catalogo_content_lang".$_POST['newlangname']." SELECT * FROM catalogo_content");

    // creazione lingua per metaname
    $connh->Execute("CREATE TABLE metaname_lang".$_POST['newlangname']." SELECT * FROM metaname");

}


if ($_POST['action'] == 'deletelang') {
    while (!$rscontents->EOF) {
        $t = $rscontents->fields['contenuto'] . '_lang' . $_POST['deletelangname'];
        if (in_array($t, $tables))
            $connh->Execute("DROP TABLE IF EXISTS `" . $t . "`");
        $rscontents->MoveNext();
    } 
    $rscontents->MoveFirst();
    $connh->Execute("DROP TABLE IF EXISTS `catalogo_content_lang" . $_POST['deletelangname'] . "`");
    $connh->Execute("DROP TABLE IF EXISTS `metaname_lang" . $_POST['deletelangname'] . "`");
}

getLanguagesStruct($langlabels, $langs);

if ($_POST['action'] == 'salvatraduzione') {

    foreach ($_POST['data'] as $langtable => $a) {

        if (substr($langtable, 0, 9) == "metaname_") {
            $a["dctitle"] = $a["metaname_dctitle"];
            $a["description"] = $a["metaname_description"];
            $a["keywords"] = $a["metaname_keywords"];
        }
        
        unset($a["metaname_dctitle"]);
        unset($a["metaname_description"]);
        unset($a["metaname_keywords"]);

        if (trim(implode('', array_values($a))) == '')
            continue;

        if ($_POST['sqlop'][$langtable] == 'update') {
            update($langtable, $_POST['idnode'], $a, $connh);

        }
        else if ($_POST['sqlop'][$langtable] == 'insert') {
            $a['id'] = $_POST['idnode'];
            insert($langtable, $a, $connh);
        }
    }
}

?>

<script type="text/javascript">
var langlabels = new Array();
<?
foreach ($langlabels as $lang) {
    echo "\nlanglabels.push('$lang');";
}
?>

function newlang() {
    if (lang = prompt("Nome della lingua in tre caratteri")) {
        if (lang.length == 3) {
            document.getElementById('newlangname').value = lang;
            document.getElementById('action').value = 'newlang';
            document.getElementById('swaplangform').submit();
        }
        else
            alert('Il nome della lingua deve essere di tre caratteri al massimo');
    }
}

function deletelang(lang) {
    if (confirm("Vuoi veramente eliminare la lingua '" + lang + "' e tutti i suoi contenuti?")) {
            document.getElementById('deletelangname').value = lang;
            document.getElementById('action').value = 'deletelang';
            document.getElementById('swaplangform').submit();
    }
    else
        alert("Eliminazione lingua annullata");

}


function traduci(id) {
    document.getElementById('action').value = 'traduci';
    document.getElementById('idnode').value = id;
    document.getElementById('swaplangform').submit();
}

function salvatrad(id) {
    document.getElementById('action').value = 'salvatraduzione';
    document.getElementById('idnode').value = id;
    document.getElementById('swaplangform').submit();
}

function annullatrad() {
    document.getElementById('action').value = 'annulla';
    document.getElementById('swaplangform').submit();
}

function setactivelang(lang) {
    var c, i;
    var activelang = document.getElementById(lang + '_tab');
    activelang.setAttribute('class', 'table_sez');
    for (c = 1; c <= totfields; c++)
        document.getElementById(lang + String(c)).style.display = '';

    for (i = 0; i < langlabels.length; i++) {
        if (langlabels[i] != lang) {
            document.getElementById(langlabels[i] + '_tab').setAttribute('class', 'insert_voice');
            for (c = 1; c <= totfields; c++)
                document.getElementById(langlabels[i] + String(c)).style.display = 'none';
        }
    }
}

</script>

<form method="post" id="swaplangform">
<input type="hidden" name="newlangname" id="newlangname" />
<input type="hidden" name="deletelangname" id="deletelangname" />
<input type="hidden" name="action" id="action" />
<input type="hidden" name="idnode" id="idnode" />

<?
if ($_POST['action'] == 'traduci') {
?>
<div id="overlay" onclick="annullatrad()" style="position:fixed;top:0;left:0;width:100%;height:100%;opacity:0.65;background-color:gray;"></div>
<?
}
?>

<table width="<? include("include/dim_all.inc.php"); ?>" class="table_border" align="center" cellpadding="3" cellspacing="1" border="0">
<tr>
    <th class="table_tit" colspan="<?= count($langlabels) + 3;?>">GESTIONE LINGUE DEL SITO
    <p>Lingua originale <em><?= SWAPLANG_DEFAULT_LANG;?></em></p>
    </th>
</tr><tr>
    <th rowspan="2" class="table_sez">NODO</th>
    <th rowspan="2" class="table_sez">TABELLA DI CONTENUTO</th>
    <th colspan="<?= count($langlabels) + 1;?>" class="table_sez">TRADUZIONI <a href="javascript:;" onclick="newlang()">[CREA NUOVA LINGUA]</a></th>
</tr><tr>
<?
if (count($langlabels)) {
    // lingua 3 lettere => lingua completa
    foreach ($langlabels as $lang) {
        echo "<th class=\"table_sez\">$lang&nbsp;<a href=\"javascript:deletelang('$lang');\">" . "[X]" . "</a></th>\n";
    }
    echo "<th class=\"table_sez\">AZIONI</th>";
}
else
    echo "<th class=\"table_sez\">&nbsp;</th>";
?>
</tr>
<?
$c = 0;
$rsnode = $connh->Execute("SELECT * FROM node ORDER BY sezione");
while (!$rsnode->EOF) {
    if ($_POST['action'] == 'traduci' && $_POST['idnode'] == $rsnode->fields['id']) {
        $class = 'button_out';
        $rsnode->fields['sezione'] = "<strong>".$rsnode->fields['sezione']."</strong>";
    }
    else
        $class = ($c % 2) ? "insert_voice" : "insert_voice_dark";
    $rscontent = $connh->Execute("SELECT * FROM ".$rsnode->fields['contenuto']." WHERE id='".$rsnode->fields['id']."'");

    echo "<tr>
    <td class=\"$class\"><a href=\"".PRISCILLA_SERVER_PATH."index.php?id=".$rsnode->fields['id']."\">".$rsnode->fields['sezione']."</a></td>
    <td class=\"$class\">".$rsnode->fields['contenuto']."</td>";
    if (count($langs)) {
        foreach ($langs[$rsnode->fields['contenuto']] as $langtable => $lang) {
            $rscontentlang = $connh->Execute("SELECT * FROM ".$langtable." WHERE id='".$rsnode->fields['id']."'");
            
            if ($rscontentlang->RecordCount() > 0) {
                if ($rscontent->RecordCount() <= 0 || md5content($rscontentlang->fields) != md5content($rscontent->fields))
                    $t = "tradotto";
                else
                    $t = "non tradotto";
                echo "<td class=\"$class\">".$t."</td>";
            }
            else
                echo "<td class=\"$class\">non tradotto</td>";
        }
        echo "<td class=\"button_out\"><a href=\"javascript:;\" onclick=\"traduci(".$rsnode->fields['id'].")\">traduci</a></td>";
    }
    else
        echo "<th class=\"table_sez\">&nbsp;</th>";
    echo "</tr>";

    // traduzione del nodo selezionato
    if ($_POST['action'] == 'traduci' && $_POST['idnode'] == $rsnode->fields['id']) {
        // raccolgo il recordset di contenuto di lingua originale
        $rsc = $connh->Execute("SELECT * FROM ".$rsnode->fields['contenuto']." WHERE id='".$rsnode->fields['id']."'");


        $rsmetadefault = $connh->Execute("SELECT `keywords` as `metaname_keywords`, `dctitle` as `metaname_dctitle`, `description` as `metaname_description` FROM `metaname`" . " WHERE `id` = " . $rsnode->fields('id') . " LIMIT 1");
        if (!$rsmetadefault)
            die("Fatal Error: " . $connh->ErrorMsg());


        $sqlops = '';

        $rslangs = array();
        echo "<tr><td style=\"width:100%;height:100%;top:0%;left:0%;position:absolute;vertical-align:middle;align:center;\" colspan=\"".(count($langlabels) + 3)."\">
        <table style=\"width:100%;height:100%;\" class=\"table_border\">
        <tr>
        <th class=\"table_sez\">CAMPO</th><th class=\"table_sez\">TESTO ORIGINALE</th>";
        $c = 1;
        foreach ($langs[$rsnode->fields['contenuto']] as $langtable => $lang) {
            // per ogni lingua di traduzione raccolgo recordset
            $rslang = $connh->Execute("SELECT * FROM ".$langtable." WHERE id='".$rsnode->fields['id']."'");

            if ($rslang->RecordCount() > 0) {
                $rslangs[$langtable] = $rslang->fields;
                $sqlops .= "<input type=\"hidden\" name=\"sqlop[".$langtable."]\" id=\"sqlop$c\" value=\"update\" />";
            }
            else {
                $rslangs[$langtable] = array();
                $sqlops .= "<input type=\"hidden\" name=\"sqlop[".$langtable."]\" id=\"sqlop$c\" value=\"insert\" />";
            }

            $rsmetal = $connh->Execute("SELECT `keywords` as `metaname_keywords`, `dctitle` as `metaname_dctitle`, `description` as `metaname_description` FROM `metaname_lang" . "$lang` WHERE `id` = " . $rsnode->fields('id') . " LIMIT 1");
            if (!$rsmetal)
                die("Fatal Error: " . $connh->ErrorMsg());

            $metanametable = "metaname_lang" . $lang;

            if ($rsmetal->RecordCount() > 0) {
                $rslangs[$metanametable] = $rsmetal->fields;
                $sqlops .= "<input type=\"hidden\" name=\"sqlop[". $metanametable ."]\" value=\"update\" />";
            }
            else {
                $rslangs[$metanametable] = array("id" => $rsnode->fields('id'), "metaname_keywords" => "", "metaname_dctitle" => "", "metaname_description" => "");
                $sqlops .= "<input type=\"hidden\" name=\"sqlop[". $metanametable ."]\" value=\"insert\" />";
            }

            // e anche i metaname
            $rsmeta = $connh->Execute("SELECT `keywords` as `metaname_keywords`, `dctitle` as `metaname_dctitle`, `description` as `metaname_description` FROM `metaname_lang" . $lang . "` WHERE `id` = " . $rsnode->fields('id') . " LIMIT 1");
            if (!$rsmeta)
                die("Fatal Error: " . $connh->ErrorMsg());


            if ($c > 1) 
                $att = "class=\"insert_voice\"";
            else
                $att = "class=\"table_sez\"";

            echo "<th $att id=\"".$lang."_tab\"><a href=\"#\" style=\"display:block;\" onclick=\"setactivelang('".$lang."')\">".$lang."</a></th>";

            $c++;
        }
        echo "</tr>";

        $cols = $connh->MetaColumns($rsnode->fields['contenuto']);
        $jslangstructfields = '';
        $i = 1;


        $a_metas = array("metaname_keywords", "metaname_dctitle", "metaname_description");

        foreach ($a_metas as $mt) {
            $fo = new FakeObj();
            $fo->name = $mt;
            $fo->type = "varchar";
            $cols[$mt] = $fo;
            unset($fo);
        }



        $a_seen = array();

        foreach ($cols as $fieldobj) {

            if ($fieldobj->name == 'id')
                continue;

            if ($fieldobj->type == "text")
                $s_field = "<textarea rows=\"30\" readonly style=\"position:relative;width:100%;height:100%\">" . stripslashes($rsc->fields[$fieldobj->name]) . "</textarea>\n";
            else
                $s_field = stripslashes($rsc->fields[$fieldobj->name]);


            if ($fieldobj->binary == "fakeobj") {
                $fname = "METANAME<br />" . str_replace("metaname_", "", $fieldobj->name);
                $s_field = $rsmetadefault->fields($fieldobj->name);
            } else {
                $fname = $fieldobj->name;
            }

            echo "<tr>\n";
            echo "<td class=\"insert_voice\" style=\"width:5%;vertical-align:center\">". $fname . "</td>\n".
                 "<td class=\"insert_voice\" style=\"width:45%;vertical-align:center\">" . $s_field  . "</td>\n";

            $c = 1;
            foreach ($rslangs as $langt => $langrow) {



                if ($fieldobj->binary == "fakeobj") {
                    $a_lt = explode("_", $langt);
                    $langt = "metaname_" . $a_lt[count($a_lt) - 1];
               }

                

                if (substr($fieldobj->name, 0, 9) != "metaname_" && substr($langt, 0, 9) == "metaname_")
                    continue;


/*
                echo "<pre>$langt";
                print_r($langrow);
                echo "</pre>";
*/
 
                if ($c > 1) 
                    $att = "style=\"display:none;\"";
                else
                    $att = "";

                echo "<td class=\"insert_voice\" colspan=\"".(count($cols) - 1)."\" $att id=\"".substr($langt, -3).$i."\">\n";


                $fname = $fieldobj->name;

                if (in_array($langt . $fname, $a_seen))
                    continue;

                switch ($fieldobj->type) {

                    case 'text':
                    echo "<textarea name=\"data[".$langt."][".$fieldobj->name."]\" id=\"data_".$langt."_".$fieldobj->name."\" class=\"insert_area\" rows=\"40\" style=\"position:relative;width:100%;\">".stripslashes($langrow[$fieldobj->name])."</textarea>\n";
                    break;
                    default:

                    if ($fieldobj->binary == "fakeobj")
                        $vv = htmlspecialchars(stripslashes($rslangs[$langt][$fname]));
                    else
                        $vv = htmlspecialchars(stripslashes($langrow[$fname]));
 
                    echo "\n<input type=\"text\" name=\"data[".$langt."][". $fname ."]\" id=\"data_".$langt."_". $fname ."\" maxlength=\"255\" value=\"". $vv ."\" class=\"insert_area\" style=\"position:relative;width:100%\"/>\n";
 
                    $a_seen[] = $langt . $fname;

                    break;
                }
                echo "</td>\n";

                $c++;
            }
            echo "</tr>\n";
            $i++;
        }
        
        echo "<tr>
        <td class=\"table_sez\" colspan=\"".(count($cols) + 1)."\" style=\"text-align:center\"><input type=\"button\" value=\"salva le traduzioni\" class=\"button_out awesome\" onclick=\"salvatrad(".$rsnode->fields['id'].")\"/><input type=\"button\" value=\"annulla\" class=\"button_out awesome\" onclick=\"annullatrad()\"/></td>
        </tr>
        </table>$sqlops</td></tr>\n";
    }

    $c++;
    $rsnode->MoveNext();
}
?>
</table>
<?
if (count($cols)) {
?>
<script type="text/javascript">
var totfields = <? echo count($cols) - 1; ?>;
</script>
<?
}
// fix per piede
$lang = SWAPLANG_DEFAULT_LANG;
?>
</form>
